

Procedure AddTreeGadgetImage(gadget,image)
  himl = SendMessage_(GadgetID(gadget),#TVM_GETIMAGELIST,#TVSIL_NORMAL,0)
  If himl=0 ;no icons in tree?
    himl = ImageList_Create_(16,16,#ILC_COLOR8|#ILC_MASK,1,1)
    SendMessage_(GadgetID(gadget),#TVM_SETIMAGELIST,#TVSIL_NORMAL ,himl)
  EndIf
  ProcedureReturn ImageList_AddIcon_(himl,image)
EndProcedure

Procedure GetTreeGadgetImage(gadget,item)
  pitem.TV_ITEM\mask   = #TVIF_IMAGE
  pitem\hItem  = GadgetItemID(gadget,item)
  SendMessage_(GadgetID(gadget),#TVM_SETITEM,0,pitem)
  ProcedureReturn pitem\iImage
EndProcedure
  
Procedure ChangeTreeItemImage(gadget,item,image,imageselected)
  pitem.TV_ITEM\mask   = #TVIF_IMAGE|#TVIF_SELECTEDIMAGE
  pitem\hItem  = GadgetItemID(gadget,item)
  pitem\iImage = image
  pitem\iSelectedImage = imageselected
 SendMessage_(GadgetID(gadget),#TVM_SETITEM,0,pitem)
EndProcedure

Procedure CheckTreeGadgetNodes(gadget,image1,image2)
  For item=0 To CountGadgetItems(gadget)
    If CountTreeGadgetNodeItems(gadget,item)
      state = GetGadgetItemState(gadget,item) 
      If state & #PB_Tree_Expanded And GetTreeGadgetImage(gadget,item)<>image2
        ChangeTreeItemImage(gadget,item,image2,image2)
      ElseIf state & #PB_Tree_Collapsed And GetTreeGadgetImage(gadget,item)<>image1
        ChangeTreeItemImage(gadget,item,image1,image1)
      EndIf
    EndIf
  Next item
EndProcedure  

;______icon-catch___
CatchImage(0,?book)
CatchImage(1,?book2)
CatchImage(2,?side)
;___________________


;____________main_program____________
OpenWindow(0,0,0,150,250,#PB_Window_SystemMenu|#PB_Window_ScreenCentered,"TreeGadget")
CreateGadgetList(WindowID())
TreeGadget(0,0,0,150,250,#PB_Tree_AlwaysShowSelection|#PB_Tree_NoLines)

;Create some items for the TreeGadget
For i=1 To 50
  AddGadgetItem(0,-1,"Part "+Str(i),UseImage(0))
  OpenTreeGadgetNode(0)
    AddGadgetItem(0,-1,"Side a",UseImage(2))
    AddGadgetItem(0,-1,"Side b",UseImage(2))
    AddGadgetItem(0,-1,"Sub-part 1",UseImage(0))
    OpenTreeGadgetNode(0)
      AddGadgetItem(0,-1,"Side a",UseImage(2))
      AddGadgetItem(0,-1,"Side b",UseImage(2))
      AddGadgetItem(0,-1,"Sub-part 2",UseImage(0))
      OpenTreeGadgetNode(0)
      AddGadgetItem(0,-1,"Side a",UseImage(2))
      AddGadgetItem(0,-1,"Sub-part 3",UseImage(0))
      OpenTreeGadgetNode(0)
        AddGadgetItem(0,-1,"Side a",UseImage(2))
        AddGadgetItem(0,-1,"Side b",UseImage(2))
      CloseTreeGadgetNode(0) 
        AddGadgetItem(0,-1,"Side b",UseImage(2))
      CloseTreeGadgetNode(0) 
    CloseTreeGadgetNode(0)  
  CloseTreeGadgetNode(0)
Next i

;Add an image in TreeGadget(TreeView)
openedbook=AddTreeGadgetImage(0,UseImage(1))


Repeat
  EventID  = WaitWindowEvent()
  If EventID = #PB_EventGadget
    Select EventGadgetID()
      Case 0
        state = GetGadgetState(0)
        item  = GadgetItemID(0,state)
        SendMessage_(GadgetID(0),#TVM_ENSUREVISIBLE,0,item)
        CheckTreeGadgetNodes(0,1,openedbook)

        ;....
      
      
    EndSelect
  ElseIf GetFocus_()=GadgetID(0)
    If EventID=#WM_KEYDOWN And keybuffer=0
      wparam = EventwParam()
      If wparam=37 Or wparam=39
        state = GetGadgetState(0)
        item  = GadgetItemID(0,state)
        SendMessage_(GadgetID(0),#TVM_ENSUREVISIBLE,0,item)
        CheckTreeGadgetNodes(0,1,openedbook)
      EndIf
      keybuffer=1
    ElseIf EventID=#WM_KEYUP
      keybuffer=0
    EndIf
  EndIf
Until EventID = #PB_EventCloseWindow
End  
;______________________________


book:
IncludeBinary "bookclose.ico"
book2:
IncludeBinary "bookopen.ico"
side:
IncludeBinary "sideicon.ico"
; ExecutableFormat=Windows
; CursorPosition=89
; FirstLine=86
; EnableNT4
; UseIcon=..\..\
; Executable=E:\Documents and Settings\Administrateur\Bureau\Splitter\Splitter.exe
; EOF
